Package net.sf.saxon.tree.linked

## Class ParentNodeImpl

- java.lang.Object
- - net.sf.saxon.tree.linked.NodeImpl
  - - net.sf.saxon.tree.linked.ParentNodeImpl

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `MutableNodeInfo`, `NodeInfo`, `Sequence`, `Location`, `SteppingNode<NodeImpl>`, `SiblingCountingNode`, `org.xml.sax.Locator`
  Direct Known Subclasses:
    `DocumentImpl`, `ElementImpl`

      public abstract class ParentNodeImpl
      extends NodeImpl

  ParentNodeImpl is an implementation of a non-leaf node (specifically, an Element node or a Document node)

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.tree.linked.NodeImpl

      `NODE_LETTER`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ParentNodeImpl()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `addChild​(NodeImpl node, int index)` | Add a child node to this node.
    `java.lang.Iterable<NodeImpl>` | `children()` | Return the sequence of children of this node, as an `Iterable`.
    `void` | `compact​(int size)` | Compact the space used by this node
    `NodeImpl` | `getFirstChild()` | Get the first child node of the element
    `NodeImpl` | `getLastChild()` | Get the last child node of the element
    `protected NodeImpl` | `getNthChild​(int n)` | Get the nth child node of the element (numbering from 0)
    `int` | `getNumberOfChildren()` | Determine how many children the node has
    `protected int` | `getRawSequenceNumber()` |
    `protected long` | `getSequenceNumber()` | Get the node sequence number (in document order).
    `java.lang.String` | `getStringValue()` | Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the value of the item as a CharSequence.
    `boolean` | `hasChildNodes()` | Determine if the node has any children.
    `void` | `insertChildren​(NodeInfo[] source, boolean atStart, boolean inherit)` | Insert a sequence of nodes as children of this node.
    `protected AxisIterator` | `iterateChildren​(java.util.function.Predicate<? super NodeInfo> test)` | Get an enumeration of the children of this node
    `protected void` | `removeChild​(NodeImpl child)` | Remove a given child
    `protected void` | `replaceChildrenAt​(NodeInfo[] source, int index, boolean inherit)` | Replace child at a given index by new children
    `protected void` | `setChildren​(java.lang.Object children)` | Set the children of this node
    `protected void` | `setRawSequenceNumber​(int seq)` |

    - ### Methods inherited from class net.sf.saxon.tree.linked.NodeImpl

      `addAttribute, addNamespace, atomize, attributes, compareOrder, delete, effectiveBooleanValue, equals, generateId, getAllNamespaces, getAttributeValue, getBaseURI, getColumnNumber, getConfiguration, getDeclaredNamespaces, getDisplayName, getFingerprint, getLineNumber, getLocalPart, getNamePool, getNextInDocument, getNextSibling, getNodeName, getParent, getPhysicalRoot, getPrefix, getPreviousInDocument, getPreviousSibling, getRawParent, getRoot, getSchemaType, getSiblingPosition, getSuccessorElement, getSystemId, getTreeInfo, getURI, hasFingerprint, head, insertSiblings, isDeleted, iterateAxis, iterateAxis, newBuilder, removeAttribute, removeTypeAnnotation, rename, replace, saveLocation, setAttributes, setRawParent, setSiblingPosition, setSystemId, setTypeAnnotation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.MutableNodeInfo

      `addNamespace, removeNamespace, replaceStringValue`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `children, copy, equals, getGenre, getNodeKind, getPublicId, hashCode, isId, isIdref, isNilled, isSameNodeInfo, isStreamed, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Constructor Detail

    - #### ParentNodeImpl

          public ParentNodeImpl()

  - ### Method Detail

    - #### getSequenceNumber

          protected final long getSequenceNumber()

      Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. In the current implementation, parent nodes (elements and document nodes) have a zero least-significant word, while namespaces, attributes, text nodes, comments, and PIs have the top word the same as their owner and the bottom half reflecting their relative position. For nodes added by XQuery Update, the sequence number is -1L
      Overrides:
        `getSequenceNumber` in class `NodeImpl`
      Returns:
        the sequence number if there is one, or -1L otherwise.

    - #### getRawSequenceNumber

          protected final int getRawSequenceNumber()

    - #### setRawSequenceNumber

          protected final void setRawSequenceNumber​(int seq)

    - #### setChildren

          protected final void setChildren​(java.lang.Object children)

      Set the children of this node
      Parameters:
        `children` - null if there are no children, a single NodeInfo if there is one child, an array of NodeInfo if there are multiple children

    - #### hasChildNodes

          public final boolean hasChildNodes()

      Determine if the node has any children.
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Overrides:
        `hasChildNodes` in class `NodeImpl`
      Returns:
        `true` if the node has any children, `false` if the node has no children.

    - #### children

          public java.lang.Iterable<NodeImpl> children()

      Return the sequence of children of this node, as an `Iterable`. This method is designed to allow iteration over the children in a Java "for each" loop, in the form `for (NodeInfo child : children()) {...}`
      Returns:
        the children of the node, as an `Iterable`.

    - #### getNumberOfChildren

          public final int getNumberOfChildren()

      Determine how many children the node has
      Returns:
        the number of children of this parent node

    - #### iterateChildren

          protected final AxisIterator iterateChildren​(java.util.function.Predicate<? super NodeInfo> test)

      Get an enumeration of the children of this node
      Parameters:
        `test` - A NodeTest to be satisfied by the child nodes, or null if all child node are to be returned
      Returns:
        an iterator over the children of this node

    - #### getFirstChild

          public final NodeImpl getFirstChild()

      Get the first child node of the element
      Specified by:
        `getFirstChild` in interface `SteppingNode<NodeImpl>`
      Overrides:
        `getFirstChild` in class `NodeImpl`
      Returns:
        the first child node of the required type, or null if there are no children

    - #### getLastChild

          public final NodeImpl getLastChild()

      Get the last child node of the element
      Overrides:
        `getLastChild` in class `NodeImpl`
      Returns:
        the last child of the element, or null if there are no children

    - #### getNthChild

          protected final NodeImpl getNthChild​(int n)

      Get the nth child node of the element (numbering from 0)
      Parameters:
        `n` - identifies the required child
      Returns:
        the last child of the element, or null if there is no n'th child

    - #### removeChild

          protected void removeChild​(NodeImpl child)

      Remove a given child
      Parameters:
        `child` - the child to be removed

    - #### getStringValue

          public java.lang.String getStringValue()

      Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.
      Returns:
        the accumulated character content of the element, including descendant elements.
      See Also:
        `Item.getStringValueCS()`

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Description copied from class: `NodeImpl`
      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Overrides:
        `getStringValueCS` in class `NodeImpl`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### addChild

          protected void addChild​(NodeImpl node,
                                  int index)

      Add a child node to this node. For system use only. Note: normalizing adjacent text nodes is the responsibility of the caller.
      Parameters:
        `node` - the node to be added as a child of this node. This must be an instance of `NodeImpl`. It will be modified as a result of this call (by setting its parent property and sibling position)
        `index` - the position where the child is to be added

    - #### insertChildren

          public void insertChildren​(NodeInfo[] source,
                                     boolean atStart,
                                     boolean inherit)

      Insert a sequence of nodes as children of this node.

      This method takes no action unless the target node is a document node or element node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

      The supplied nodes will form the new children. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

      Specified by:
        `insertChildren` in interface `MutableNodeInfo`
      Overrides:
        `insertChildren` in class `NodeImpl`
      Parameters:
        `source` - the nodes to be inserted. The implementation determines what implementation classes of node it will accept; this implementation will accept text, comment, and processing instruction nodes belonging to any implementation, but elements must be instances of `ElementImpl`. The supplied nodes will be modified in situ, for example to change their parent property and to add namespace bindings, if they are instances of `ElementImpl`; otherwise they will be copied. If the nodes are copied, then on return the supplied source array will contain the copy rather than the original.
        `atStart` - true if the new nodes are to be inserted before existing children; false if they are to be inserted after existing children
        `inherit` - true if the inserted nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
      Throws:
        `java.lang.IllegalArgumentException` - if the supplied nodes use a node implementation that this implementation does not accept.

    - #### replaceChildrenAt

          protected void replaceChildrenAt​(NodeInfo[] source,
                                           int index,
                                           boolean inherit)

      Replace child at a given index by new children
      Parameters:
        `source` - the children to be inserted
        `index` - the position at which they are to be inserted: 0 indicates replacement of the first child, replacement of the second child, and so on. The effect is undefined if index is out of range
        `inherit` - set to true if the new child elements are to inherit the in-scope namespaces of their new parent
      Throws:
        `java.lang.IllegalArgumentException` - if any of the replacement nodes is not an element, text, comment, or processing instruction node

    - #### compact

          public void compact​(int size)

      Compact the space used by this node
      Parameters:
        `size` - the number of actual children